import fetch from "node-fetch";
import { BaseResponse } from "../Api";
import { ClientResponse } from "./ClientResponse";
import { ClientAbstract } from "./ClientAbstract";
import { ClientRequestOptions } from "./ClientOptions";
export declare class ClientRequestAbstract extends ClientAbstract {
    /**
     * HTTP Client
     *
     * @returns {(url: (string | Request), init?: RequestInit) => Promise<Response>}
     */
    get client(): typeof fetch;
    /**
     *
     */
    ping(): Promise<ClientResponse<BaseResponse>>;
    /**
     * Create request to an API endpoint.
     *
     * @param {string} url
     * @param {ClientRequestOptions} options
     * @returns {Promise<ClientResponse<BaseResponse>>}
     */
    protected call<R extends BaseResponse>(url: string, options: ClientRequestOptions): Promise<R>;
}
